<?php

namespace RecruitCrm\LogicMelon\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCQueryLocation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCQueryLocation
 * @subpackage Arrays
 */
class ArrayOfCQueryLocation extends AbstractStructArrayBase
{
    /**
     * The CQueryLocation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \RecruitCrm\LogicMelon\StructType\CQueryLocation[]
     */
    public $CQueryLocation;
    /**
     * Constructor method for ArrayOfCQueryLocation
     * @uses ArrayOfCQueryLocation::setCQueryLocation()
     * @param \RecruitCrm\LogicMelon\StructType\CQueryLocation[] $cQueryLocation
     */
    public function __construct(array $cQueryLocation = array())
    {
        $this
            ->setCQueryLocation($cQueryLocation);
    }
    /**
     * Get CQueryLocation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \RecruitCrm\LogicMelon\StructType\CQueryLocation[]|null
     */
    public function getCQueryLocation()
    {
        return isset($this->CQueryLocation) ? $this->CQueryLocation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCQueryLocation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCQueryLocation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCQueryLocationForArrayConstraintsFromSetCQueryLocation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCQueryLocationCQueryLocationItem) {
            // validation for constraint: itemType
            if (!$arrayOfCQueryLocationCQueryLocationItem instanceof \RecruitCrm\LogicMelon\StructType\CQueryLocation) {
                $invalidValues[] = is_object($arrayOfCQueryLocationCQueryLocationItem) ? get_class($arrayOfCQueryLocationCQueryLocationItem) : sprintf('%s(%s)', gettype($arrayOfCQueryLocationCQueryLocationItem), var_export($arrayOfCQueryLocationCQueryLocationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CQueryLocation property can only contain items of type \RecruitCrm\LogicMelon\StructType\CQueryLocation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CQueryLocation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\CQueryLocation[] $cQueryLocation
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfCQueryLocation
     */
    public function setCQueryLocation(array $cQueryLocation = array())
    {
        // validation for constraint: array
        if ('' !== ($cQueryLocationArrayErrorMessage = self::validateCQueryLocationForArrayConstraintsFromSetCQueryLocation($cQueryLocation))) {
            throw new \InvalidArgumentException($cQueryLocationArrayErrorMessage, __LINE__);
        }
        if (is_null($cQueryLocation) || (is_array($cQueryLocation) && empty($cQueryLocation))) {
            unset($this->CQueryLocation);
        } else {
            $this->CQueryLocation = $cQueryLocation;
        }
        return $this;
    }
    /**
     * Add item to CQueryLocation value
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\CQueryLocation $item
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfCQueryLocation
     */
    public function addToCQueryLocation(\RecruitCrm\LogicMelon\StructType\CQueryLocation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \RecruitCrm\LogicMelon\StructType\CQueryLocation) {
            throw new \InvalidArgumentException(sprintf('The CQueryLocation property can only contain items of type \RecruitCrm\LogicMelon\StructType\CQueryLocation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CQueryLocation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \RecruitCrm\LogicMelon\StructType\CQueryLocation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \RecruitCrm\LogicMelon\StructType\CQueryLocation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \RecruitCrm\LogicMelon\StructType\CQueryLocation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \RecruitCrm\LogicMelon\StructType\CQueryLocation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \RecruitCrm\LogicMelon\StructType\CQueryLocation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CQueryLocation
     */
    public function getAttributeName()
    {
        return 'CQueryLocation';
    }
}
